<template>
  <div id="resources">
    <coscine-headline :headline="$t('resources')" />
    <div class="ResourceList">
      <b-card-group deck class="dashboard">
        <coscine-card
          :displayName="$t('addResource')"
          :imagePath="zusatzImage"
          :cardLink="openCreateResource()"
        />
        <coscine-card
          v-for="(resource, index) in resources"
          :key="index"
          :displayName="resource.displayName"
          :imagePath="resourceImage"
          :cardLink="openViewResource(resource.id)"
          :editLink="openCreateResource(resource.id)"
          :flag_visible="resource.archived"
          :flag_text="$t('archive.archived')"
        />
      </b-card-group>
    </div>
  </div>
</template>

<script lang="ts">
import { CardPlugin } from "bootstrap-vue";
import Vue from "vue";
import { GuidUtil, LinkUtil } from "@coscine/app-util";
import { ProjectApi } from "@coscine/api-connection";
import { CoscineCard, CoscineHeadline } from "@coscine/component-library";
import "@coscine/component-library/dist/index.css";

import resourceImagePath from "./assets/RWTH_Piktogramm_Unternehmen.png";
import zusatzImagePath from "./assets/RWTH_Piktogramm_Zusatzangebot.png";

let pathToAppJs = "";
if (document.currentScript !== undefined) {
  pathToAppJs = (document.currentScript as any).src as string;
}

Vue.use(CardPlugin);

export default Vue.extend({
  name: "resources",
  components: {
    CoscineCard,
    CoscineHeadline,
  },
  data() {
    return {
      projectId: "",
      resources: [] as Array<unknown>,
      resourceImage: "",
      zusatzImage: "",
    };
  },
  methods: {
    openCreateResource(resourceId = "") {
      if (resourceId !== "") {
        return LinkUtil.getProjectLink("EditResource", {
          resource_id: resourceId,
        });
      } else {
        return LinkUtil.getProjectLink("CreateResource", {}, "/Setup");
      }
    },
    openViewResource(resourceId: any) {
      return LinkUtil.getProjectLink(
        "ViewResource",
        { resource_id: resourceId },
        ""
      );
    },
  },
  created() {
    this.projectId = GuidUtil.getProjectId();
    this.resourceImage =
      LinkUtil.getScriptPath(pathToAppJs) + resourceImagePath;
    this.zusatzImage = LinkUtil.getScriptPath(pathToAppJs) + zusatzImagePath;
  },
  mounted() {
    ProjectApi.getResources(this.projectId, (response: any) => {
      for (const datum of response.data) {
        this.resources.push(datum);
      }
    });
  },
});
</script>
